#include <iostream>

#include "BJC/System/Static.h"
#include "BJC/System/Shared.h"
#include "BJC/System/DLOpenedIFace.h"

#include <ltdl.h>
#include <iostream>
using namespace std;

typedef DLOpenedIFace* (*LibraryFunction)();

//const char* search_path = "../../plugins/LTDLOpened";
const char* search_path = "";

int main()
{
   LTDL_SET_PRELOADED_SYMBOLS();
   
   Static::Function();
   Shared::Function();
   std::cout << "Hello from main app." << std::endl;
   
   
   int result = lt_dlinit();
   if(result != 0)
   {
      std::cerr << "Failed to initialize ltdl." << std::endl;
      std::cerr << "Error Code: " << result << std::endl;
      std::cerr << "Error Message: " << lt_dlerror() << std::endl;
      return -1;
   }
   
   if(search_path != NULL)
   {
      result = lt_dlsetsearchpath(search_path);
      if(result != 0)
      {
         std::cerr << "Failed to set the search path." << std::endl;
         std::cerr << "Error Code: " << result << std::endl;
         std::cerr << "Error Message: " << lt_dlerror() << std::endl;
         return -1;
      }
   }

   lt_dlhandle module = lt_dlopenext("LTDLOpened");
   if(!module)
   {
      std::cerr << "Failed to load the module." << std::endl;
      //std::cerr << "Error Code: " << module << std::endl;
      std::cerr << "Error Message: " << lt_dlerror() << std::endl;
      return -1;
   }

   LibraryFunction run = (LibraryFunction) lt_dlsym(module, "GetInstance");
   // run may legitimatly be NULL, so we use lt_dlerror to check.
   const char* error_message = lt_dlerror();
   if(error_message != NULL)
   {
      std::cerr << "Failed to get the symbol: GetInstance" << std::endl;
      std::cerr << "Error Message: " << error_message << std::endl;
      return -1;
   }
   
   std::cout << "Calling the GetInstance() function." << std::endl;
   DLOpenedIFace* instance = run();

   std::cout << "Running the function on the instance returned" << std::endl;
   instance->Function();


   result = lt_dlexit();
   if(result != 0)
   {
      std::cerr << "Failed to exit ltdl." << std::endl;
      std::cerr << "Error Code: " << result << std::endl;
      std::cerr << "Error Message: " << lt_dlerror() << std::endl;
      return -1;
   }
   return 0;
}










/*
#include "BJC/Auto/Static/Static.h"
#include "BJC/Auto/Shared/Shared.h"
#include "BJC/Auto/DLOpened/DLOpenedIFace.h"


int main()
{
   int result = lt_dlinit();
   if(result != 0)
   {
      std::cerr << "Failed to initialize ltdl." << std::endl;
      std::cerr << "Error Code: " << result << std::endl;
      std::cerr << "Error Message: " << lt_dlerror() << std::endl;
      return -1;
   }
   
   cout << "Hello world." << endl;
   Static::Function();
   Shared::Function();

   if(search_path != NULL)
   {
      result = lt_dlsetsearchpath(search_path);
      if(result != 0)
      {
         std::cerr << "Failed to set the search path." << std::endl;
         std::cerr << "Error Code: " << result << std::endl;
         std::cerr << "Error Message: " << lt_dlerror() << std::endl;
         return -1;
      }
   }

   lt_dlhandle module = lt_dlopenext("BJC_Auto_DLOpened");
   if(!module)
   {
      std::cerr << "Failed to load the module." << std::endl;
      std::cerr << "Error Code: " << module << std::endl;
      std::cerr << "Error Message: " << lt_dlerror() << std::endl;
      return -1;
   }

   LibraryFunction run = (LibraryFunction) lt_dlsym(module, "GetInstance");
   // run may legitimatly be NULL, so we use lt_dlerror to check.
   const char* error_message = lt_dlerror();
   if(error_message != NULL)
   {
      std::cerr << "Failed to get the symbol: GetInstance" << std::endl;
      std::cerr << "Error Message: " << error_message << std::endl;
      return -1;
   }
   
   std::cout << "Calling the GetInstance() function." << std::endl;
   DLOpenedIFace* instance = run();

   std::cout << "Running the function on the instance returned" << std::endl;
   instance->Function();


   result = lt_dlexit();
   if(result != 0)
   {
      std::cerr << "Failed to exit ltdl." << std::endl;
      std::cerr << "Error Code: " << result << std::endl;
      std::cerr << "Error Message: " << lt_dlerror() << std::endl;
      return -1;
   }
   
   return 0;
}
*/
